#ifndef UTIL_H
#define UTIL_H

#include <stdint.h>

/**
 * Generate a random number between min and max, inclusive
**/
int randrange(int min, int max);

/**
 * Probability generator
 */
int randchance(double prob);

/**
 * Returns the sign of a number
 * Or zero if the input is zero
 */
int sign(int x);

typedef struct args {
	int dbg;
	int load;
	int save;
	int seed;
	int nummon;
} args_t;

typedef struct {
	uint8_t x;
	uint8_t y;
} position_t;

/**
 * Parses command line arguments
 * Provides default values for arguments that do not exist
 */
void parse_args(int argc, char *argv[], args_t *args);

#endif
